<!-- Page Loader dengan kontrol manual -->
<style>
#page-loader {
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background-color: rgba(255, 255, 255, 0.8);
    backdrop-filter: blur(5px);
    z-index: 9999;
    display: none;
    justify-content: center;
    align-items: center;
    flex-direction: column;
}

#loader-control {
    margin-top: 20px;
    padding: 10px 15px;
    background-color: #dc3545;
    color: white;
    border: none;
    border-radius: 5px;
    cursor: pointer;
    display: none;
}

#loader-control:hover {
    background-color: #bb2d3b;
}

/* Tampilkan tombol kontrol setelah 5 detik jika loader masih tampil */
@keyframes showControl {
    to { display: block; }
}
#page-loader.stuck #loader-control {
    display: block;
}
</style>

<div id="page-loader">
    <div class="spinner-border text-primary" role="status" style="width: 3rem; height: 3rem;">
        <span class="visually-hidden">Loading...</span>
    </div>
    <div id="loader-text" style="margin-top: 10px; font-weight: bold;">Memproses...</div>
    <button id="loader-control" onclick="forceHideLoader()">Tutup Loader</button>
</div>

<script>
    // Fungsi untuk menangani loader
    function setupLoader() {
        // Sembunyikan loader secara default
        const pageLoader = document.getElementById('page-loader');
        const loaderText = document.getElementById('loader-text');
        
        if (!pageLoader) return;
        
        // Paksa sembunyikan loader jika ada
        pageLoader.style.display = 'none';
        pageLoader.classList.remove('stuck');
        
        // Fungsi untuk menampilkan loader
        window.showPageLoader = function(text) {
            console.log('Showing loader' + (text ? ': ' + text : ''));
            pageLoader.style.display = 'flex';
            pageLoader.classList.remove('stuck');
            
            // Set text jika disediakan
            if (text && loaderText) {
                loaderText.textContent = text;
            } else if (loaderText) {
                loaderText.textContent = 'Memproses...';
            }
            
            // Tandai halaman bahwa navigasi sedang berlangsung
            window.isNavigating = true;
            
            // Tambahkan class stuck setelah 3 detik jika loader masih ditampilkan
            setTimeout(function() {
                if (pageLoader.style.display === 'flex') {
                    pageLoader.classList.add('stuck');
                }
            }, 3000);
            
            // Sembunyikan loader setelah 8 detik (fallback jika event load tidak terpicu)
            setTimeout(function() {
                window.hidePageLoader();
                console.log('Auto-hiding loader after timeout');
            }, 8000);
        };
        
        // Fungsi untuk menyembunyikan loader
        window.hidePageLoader = function() {
            console.log('Hiding loader');
            pageLoader.style.display = 'none';
            pageLoader.classList.remove('stuck');
            window.isNavigating = false;
        };
        
        // Fungsi untuk paksa sembunyikan loader
        window.forceHideLoader = function() {
            pageLoader.style.display = 'none';
            pageLoader.classList.remove('stuck');
            window.isNavigating = false;
            console.log('Loader manually closed');
        };
        
        // Jalankan setiap 2 detik untuk memastikan loader disembunyikan
        const loaderCheckInterval = setInterval(function() {
            if (document.readyState === 'complete' && !window.isNavigating) {
                window.hidePageLoader();
            }
        }, 2000);
        
        // Sembunyikan loader saat halaman selesai loading
        window.addEventListener('load', function() {
            setTimeout(function() {
                window.hidePageLoader();
            }, 500);
            console.log('Page loaded, hiding loader after delay');
        });
        
        // Sembunyikan loader jika halaman sudah dimuat
        if (document.readyState === 'complete') {
            window.hidePageLoader();
            console.log('Page already loaded, hiding loader immediately');
        }
    }
    
    // Setup loader saat DOM siap
    document.addEventListener('DOMContentLoaded', setupLoader);
    
    // Sembunyikan loader secara langsung (jika DOMContentLoaded sudah terjadi)
    if (document.readyState !== 'loading') {
        setupLoader();
    }
    
    // Panggil lagi saat window load untuk memastikan
    window.addEventListener('load', setupLoader);
</script> 